*****INITIALIZE************

   CLEAR
   ZOOM WINDOW SCREEN MAX

   SET LIBRARY TO FLIPGRAF.FLL && Initialize Flipper for FoxPro

*Open fonts
   Mtext=FONT_OPEN("Times New Roman,16,N")
   boxFont=FONT_OPEN("Arial,10,N")

*Viewport
   mBaseh = ATX(100,2)
   mBasev = ATY(100,2)
   M_view = VIEW_OPEN(0,0,100,100,-1,-1,-1,"Flipper for FoxPro Demo")

   =VIEW_SIZE(M_view,0,0,mBaseh,mBasev)

   M_sec=20
   temp_view=0
   rotation=40
   elevation=10
   middle=0
   top=0
   continue=0

   =intro()
   =viewTour()
   =twodTour()
   =pieTour()
   =threedTour()
   =drawTour()
   =closing()
  SET LIBRARY TO
*******END PROGRAM*********

PROCEDURE intro
   DEFINE WINDOW Mwin AT 1,10 SIZE 30,45
   ACTIVATE WINDOW Mwin
   @ 1,1 SAY "demo.bmp" BITMAP
   =w()
   RELEASE WINDOW Mwin
   M_ok=VIEW_SHOW(M_view,3)
   M_ok=VIEW_SHOW(M_view,4)
   M_view=VIEW_SET(M_view)
   =FONT_SAY(Mtext,5,50,"Welcome to the Flipper for FoxPro demo!")
   =FONT_SAY(Mtext,5,90,"Flipper is a powerful tool for building customized graphs from your")
   =FONT_SAY(Mtext,5,115,"databases.  In this demo we hope to show you some of Flipper's")
   =FONT_SAY(Mtext,5,140,"flexibility and capability.  The demo will cover four different areas:")
   =FONT_SAY(Mtext,5,165,"viewports, 2-D graphs, pie graphs, and 3-D graphs.")
   =FONT_SAY(Mtext,5,200,"Each frame can be advanced by clicking the mouse or by pressing enter.")
   =inkey(20,"m")
   =c()
RETURN

PROCEDURE viewTour
   =VIEW_SHOW(M_view,3)
   M_ok=VIEW_SHOW(M_view,4)
   M_view=VIEW_SET(M_view)
   =FONT_SAY(Mtext,5,50,"The area in which this text")
   =FONT_SAY(Mtext,5,75,"is displayed is called a")
   =FONT_SAY(Mtext,5,100,"viewport.  Viewports are just")
   =FONT_SAY(Mtext,5,125,"Flipper for FoxPro windows")
   =FONT_SAY(Mtext,5,150,"for drawing graphics.")
   =graphData(10)
   =set_graph(4,50,0,100,100)
   =plot()
   =wc()

   =FONT_SAY(Mtext,5,50,"It's easy to plot more than")
   =FONT_SAY(Mtext,5,75,"one graph on a viewport.")
   =set_graph(4,40,0,100,50)
   =plot()
   =set_column(1,0,2)
   =set_column(3,0,2)
   =set_column(5,0,2)
   =set_graph(4,40,50,100,100)
   =plot()
   =wc()
   =FONT_SAY(Mtext,5,50,"There can be multiple view-")
   =FONT_SAY(Mtext,5,75,"ports open at the same time,")
   =FONT_SAY(Mtext,5,100,"too.")
   v1=view_open(ATX(40,2),0,ATX(69,2),ATY(48,2),-1,-1,-1,"Viewport 1")
   v2=view_open(ATX(71,2)+4,0,ATX(100,2),ATY(48,2),-1,-1,-1,"Viewport 2")
   v3=view_open(ATX(40,2),ATY(52,2)+4,ATX(69,2),ATY(100,2),-1,-1,-1,"Viewport 3")
   v4=view_open(ATX(71,2)+4,ATY(52,2)+4,ATX(100,2),ATY(100,2),-1,-1,-1,"Viewport 4")
   =view_show(v1,3)
   =view_set(v1)
   =set_graph(4,0,0,100,100)
   =plot()
   =view_show(v2,3)
   =view_set(v2)
   =plot()
   =view_show(v3,3)
   =view_set(v3)
   =plot()
   =view_show(v4,3)
   =view_set(v4)
   =plot()
   =wc()

   * close viewports
   =view_close(v1)
   =view_close(v2)
   =view_close(v3)
   =view_close(v4)

* Take *'s out to see how to retrieve positions
*   =VIEW_SET(M_view)
   * atx,aty,yat,xat example letting user click with mouse
   * then displaying percentages, world coordinates, and pixels
*   =FONT_SAY(Mtext,5,50,"Flipper offers a variety")
*   =FONT_SAY(Mtext,5,75,"of coordinate systems to ")
*   =FONT_SAY(Mtext,5,100,"suit your needs.  Viewport")
*   =FONT_SAY(Mtext,5,125,"positions can be accessed")
*   =FONT_SAY(Mtext,5,150,"by pixel, by percentage,")
*   =FONT_SAY(Mtext,5,175,"or by a user scaled system")
*   =FONT_SAY(Mtext,5,200,"called world coordinates.")
*   =wc()
*   =FONT_SAY(Mtext,5,50,"This viewport has been scaled")
*   =FONT_SAY(Mtext,5,75,"from 0,0 to 1000,1000.  Click")
*   =FONT_SAY(Mtext,5,100,"anywhere within the viewport")
*   =FONT_SAY(Mtext,5,125,"to return the location")
*   =FONT_SAY(Mtext,5,150,"specifics.  Press Esc to exit.")

*   =VIEW_SCALE(M_view,0,0,1000,1000)	&& Set the world coordinates
*   X=0			 && Initialize variables
*   Y=0

*   tempFont=FONT_OPEN("Arial,12,N")
*   DO WHILE INKEY(0,'M') != 27      && Quit if Escape is pressed*
*	 =VIEW_CLEAR(M_view,5,180,230,430)
*	 =MSPOSITION(M_view,@X,@Y)  && Get last mouse click position
*	 =FONT_SAY(tempFont,5,200,'Pixels: '+ALLTRIM(STR(X));
*	 +', '+ALLTRIM(STR(Y)))     && Display mouse pixel position
*	 wX=ALLTRIM(STR(XAT(X,0)))
*	 wY=ALLTRIM(STR(YAT(Y,0)))
*	 =FONT_SAY(tempFont,5,225,'World Coordinates: '+wX+', '+wY)
*			&& Display mouse world coordinate position
*	 pX=ALLTRIM(STR(XAT(X,2)))
*	 pY=ALLTRIM(STR(YAT(Y,2)))
*	 =FONT_SAY(tempFont,5,250,'Percentage: '+pX+', '+pY)
*		  && Display mouse percentage of the screen position
*   ENDDO
*   =FONT_CLOSE(tempFont)
*   =FONT_SAY(Mtext,5,280,"Now lets take a look at two-")
*   =FONT_SAY(Mtext,5,305,"dimensional graphs.")
*   =wc()
RETURN

PROCEDURE twodTour
   =VIEW_SHOW(M_view,3)
   M_ok=VIEW_SHOW(M_view,4)
   M_view=VIEW_SET(M_view)
   =graphData(4)
   =FONT_SAY(Mtext,5,50,"Almost every feature of the")
   =FONT_SAY(Mtext,5,75,"graphs you create is under")
   =FONT_SAY(Mtext,5,100,"your control, such as")
   =FONT_SAY(Mtext,5,135,"* the way you display your")
   =FONT_SAY(Mtext,5,160,"   data (lines, bars, etc.)")

   =set_graph(4,40,0,70,50)
   =set_column(1,0,1)
   =set_column(2,0,1)
   =set_column(3,0,1)
   =plot()
   =set_graph(4,70,0,100,50)
   =set_column(1,0,2)
   =set_column(2,0,2)
   =set_column(3,0,2)
   =plot()

   =set_graph(4,40,50,70,100)
   =set_column(1,0,3)
   =set_column(2,0,3)
   =set_column(3,0,3)
   =set_graph(13,1)
   =set_axis(1,15,20)
   =plot()

   =set_graph(4,70,50,100,100)
   =set_column(1,0,4)
   =set_column(2,0,4)
   =set_column(3,0,4)
   =set_graph(13,0)
   =set_axis(1,15,0)
   =plot()
   =w()

   =view_clear(M_view,ATX(40,2),0,mBaseh,mBasev)
   =FONT_SAY(Mtext,5,185,"* two independent Y axes")
   =set_graph(4,40,0,100,100)
   =set_column(1,0,1)
   =set_column(2,0,1)
   =set_column(3,0,1)
   =set_column(2,1,2)
   =set_graph(7,13)
   =plot()
   =w()

   =view_clear(M_view,ATX(40,2),0,mBaseh,mBasev)
   =FONT_SAY(Mtext,5,210,"* change to log scale")
   =set_axis(1,13,1)
   =plot()
   =w()

   =Flip_Reset()
   =view_clear(M_view,ATX(40,2),0,mBaseh,mBasev)
   =FONT_SAY(Mtext,5,235,"* colors, brush and line")
   =FONT_SAY(Mtext,5,260,"   patterns")
   =graphData(5)
   =plot()
   =graphData(6)
   =plot()
   =w()
   =view_clear(M_view,ATX(40,2),0,mBaseh,mBasev)

   =FONT_SAY(Mtext,5,285,"* manual scaling")
   =graphData(7)
   =plot()
   =w()
   =view_clear(M_view,ATX(40,2),0,mBaseh,mBasev)

   =FONT_SAY(Mtext,5,310,"* legends and fonts")
   =graphData(8)
   =set_graph(4,40,0,100,100)
   =plot()
   =wc()

   =Flip_Reset()
   =view_clear(M_view)
   =set_graph(4,40,0,100,50)

   =initdata(2)
   =store_data(1,8)
   =store_data(2,19)
   =store_data(3,17)
   =store_data(4,21)

   =set_column(1,0,5)
   =set_graph(10,1)

   =plot()
   mSlope=0.0
   mYinter=0.0
   mRsq=0.0
   mR=0.0
   =REGRESS(1,1,@mSlope, @mYinter, @mRsq, @mR )
   =FONT_SAY(Mtext,5,50,"Linear regression of data")
   =FONT_SAY(Mtext,5,75,"* Slope:"+STR(mSlope,6,2))
   =FONT_SAY(Mtext,5,100,"* Y intercept:"+STR(mYinter,6,2))
   =FONT_SAY(Mtext,5,125,"* Correlation Coefficient:"+STR(mRsq,6,2))
   =wc()

   * hot functions - To see this part of the demo - take out the *'s
*   =FONT_SAY(Mtext,5,50,"Flipper for FoxPro can also")
*   =FONT_SAY(Mtext,5,75,"recognize mouse presses on")
*   =FONT_SAY(Mtext,5,100,"the graph, and return what")
*   =FONT_SAY(Mtext,5,125,"graph attribute is found.")
*   =FONT_SAY(Mtext,5,160,"In this example, click")
*   =FONT_SAY(Mtext,5,185,"anywhere within the")
*   =FONT_SAY(Mtext,5,210,"viewport, and some")
*   =FONT_SAY(Mtext,5,235,"specifics will be")
*   =FONT_SAY(Mtext,5,260,"displayed.")
*   =FONT_SAY(Mtext,5,290,"Click on the quit button")
*   =FONT_SAY(Mtext,5,315,"to the left of the view-")
*   =FONT_SAY(Mtext,5,340,"port when done.")
*   =graphData(9)
*   =set_graph(4,40,0,100,100)
*   =VIEW_SIZE(M_view,40,0,mBaseh,mBasev)
*   =HOT_OPEN(M_view,BIT(),3,"DO HOT_BACK")
*   =PLOT()
*   mquit=0
*   @ 0,0 GET mquit FUNCTION '*T QUIT' SIZE 5,5
*   read
*  =HOT_CLOSE(M_view)


   IF temp_view != 0
	 =VIEW_CLOSE(temp_view)
   ENDIF
   =VIEW_SIZE(M_view,0,0,mBaseh,mBasev)
   =c()
   CLEAR
RETURN

PROCEDURE pieTour
   =VIEW_SHOW(M_view,3)
   M_ok=VIEW_SHOW(M_view,4)
   M_view=VIEW_SET(M_view)
   =graphData(1)
   * basic pie
   =set_graph(4,40,0,100,100)

   =FONT_SAY(Mtext,5,50,"Represent your data with")
   =FONT_SAY(Mtext,5,75,"easy-to-read pie graphs.")
   =pie(1)
   =wc()
   * rotate
   =FONT_SAY(Mtext,5,50,"The pie can be rotated to")
   =FONT_SAY(Mtext,5,75,"display the slices however")
   =FONT_SAY(Mtext,5,100,"you want.")
   =set_graph(24,30)
   =pie(1)
   =wc()
   * move labels
   =FONT_SAY(Mtext,5,50,"Flipper for FoxPro allows")
   =FONT_SAY(Mtext,5,75,"for a variety of settings")
   =FONT_SAY(Mtext,5,100,"for the pie labels and")
   =FONT_SAY(Mtext,5,125,"percentages.")
   =FONT_SAY(Mtext,5,160,"Here the labels have been ")
   =FONT_SAY(Mtext,5,185,"moved further from the pie")
   =FONT_SAY(Mtext,5,210,"slices.")
   =set_graph(25,12)
   =pie(1)
   =w()
   =FONT_SAY(Mtext,5,240,"Notice how the pie shrinks")
   =FONT_SAY(Mtext,5,265,"accordingly to fit within")
   =FONT_SAY(Mtext,5,290,"the graph region.")
   =wc()
   * tether off
   =FONT_SAY(Mtext,5,50,"The tether lines from the")
   =FONT_SAY(Mtext,5,75,"labels to the middle of the")
   =FONT_SAY(Mtext,5,100,"pie slices can be turned off.")
   =set_graph(27,0)
   =pie(1)
   =wc()
   * label w/percent in pie slice
   =FONT_SAY(Mtext,5,50,"Now the percents are dis-")
   =FONT_SAY(Mtext,5,75,"played inside their pie slices.")
   =set_graph(28,1)
   =pie(1)
   =w()

   * text fg/bg
   =FONT_SAY(Mtext,5,110,"As you can see, the")
   =FONT_SAY(Mtext,5,135,"percentages are hard to read.")
   =wc()
   =FONT_SAY(Mtext,5,50,"You can change the back-")
   =FONT_SAY(Mtext,5,75,"ground of the percentages")
   =FONT_SAY(Mtext,5,100,"to be the color of the pie")
   =FONT_SAY(Mtext,5,125,"slice...")
   =set_graph(30,-2)
   =pie(1)
   =w()
   =FONT_SAY(Mtext,5,150,"...as well as the foreground")
   =FONT_SAY(Mtext,5,175,"of the labels.")
   =set_graph(31,-1)
   =view_clear(M_view,ATX(40,2),0,mBaseh,mBasev)
   =pie(1)
   =wc()
   * loose the patterns
   =FONT_SAY(Mtext,5,50,"The patterns of the slices")
   =FONT_SAY(Mtext,5,75,"are for non-color printers,")
   =FONT_SAY(Mtext,5,100,"and can be turned off for")
   =FONT_SAY(Mtext,5,125,"a smoother look.")
   =set_graph(22,4)
   =pie(1)
   =wc()
   * label only
   =FONT_SAY(Mtext,5,50,"If you only want the labels,")
   =set_graph(28,2)
   =pie(1)
   =pc()
   =FONT_SAY(Mtext,5,75,"or just the percentages,")
   =set_graph(28,3)
   =pie(1)
   =w()
   =FONT_SAY(Mtext,5,100,"it's up to you.")
   * back to label and percent
   =set_graph(28,1)
   =view_clear(M_view,ATX(40,2),0,mBaseh,mBasev)
   =pie(1)
   =wc()
   * percent further in
   =FONT_SAY(Mtext,5,50,"The percentages can be")
   =FONT_SAY(Mtext,5,75,"moved a distance from the")
   =FONT_SAY(Mtext,5,100,"center of the pie.")
   =FONT_SAY(Mtext,5,125,"Here they have been moved")
   =FONT_SAY(Mtext,5,150,"further in.")
   =set_graph(29,55)
   =pie(1)
   =wc()
   * decimal accuracy
   =FONT_SAY(Mtext,5,50,"Sometimes precision can be")
   =FONT_SAY(Mtext,5,75,"important; that's why you")
   =FONT_SAY(Mtext,5,100,"can fine tune the number")
   =FONT_SAY(Mtext,5,125,"of decimal places.")
   =set_graph(28,0)
   =set_graph(32,3)
   =pie(1)
   =wc()
   * explode slices
   =FONT_SAY(Mtext,5,50,"Explode one or more pie")
   =FONT_SAY(Mtext,5,75,"slices to emphasize your")
   =FONT_SAY(Mtext,5,100,"data.")
   =set_graph(23,2)
   =pie(1)
   =w()
   * 3d pie
   =FONT_SAY(Mtext,5,150,"Impress clients with")
   =FONT_SAY(Mtext,5,175,"great looking three-")
   =FONT_SAY(Mtext,5,200,"dimensional pie graphs!")
   =set_3d(41)
   =view_clear(M_view,ATX(40,2),0,mBaseh,mBasev)
   =pie(1)
   =wc()
RETURN

PROCEDURE threedTour
   M_ok=VIEW_SHOW(M_view,4)
   M_view=VIEW_SET(M_view)
   =VIEW_SHOW(M_view,3)
   =FONT_SAY(Mtext,5,50,"Three-dimensional graphs often")
   =FONT_SAY(Mtext,5,75,"reveal better perspectives of your")
   =FONT_SAY(Mtext,5,100,"data.  Now we'll take a look")
   =FONT_SAY(Mtext,5,125,"at some of the different types")
   =FONT_SAY(Mtext,5,150,"of 3-D graphs.")

   =graphData(2)
   =set_graph(4,45,0,100,100)
   * point
   =FONT_SAY(Mtext,5,200,"For point graphs, pyramids are")
   =FONT_SAY(Mtext,5,225,"used to display the data, with")
   =FONT_SAY(Mtext,5,250,"the tip of the pyramid pointing")
   =FONT_SAY(Mtext,5,275,"to the data value.")
   =set_column(1,0,5)
   =set_column(2,0,5)
   =set_column(3,0,5)
   =set_column(4,0,5)
   =set_column(5,0,5)
   =set_column(1,3,1)
   =set_column(2,3,1)
   =set_column(3,3,1)
   =set_column(4,3,1)
   =set_column(5,3,1)
   =set_3d(rotation,elevation)
   =plot()
   =wc()
   * area
   =FONT_SAY(Mtext,5,50,"Other types of display for your")
   =FONT_SAY(Mtext,5,75,"data include")
   =FONT_SAY(Mtext,5,110,"* area graphs")
   =set_column(1,0,2)
   =set_column(2,0,2)
   =set_column(3,0,2)
   =set_column(4,0,2)
   =set_column(5,0,3)
   =plot()
   =w()
   =view_clear(M_view,atx(40,2),0,mBaseh,mBasev)
   * bar
   =FONT_SAY(Mtext,5,135,"* bar graphs")
   =set_column(1,0,3)
   =set_column(2,0,3)
   =set_column(3,0,3)
   =set_column(4,0,3)
   =set_column(5,0,3)
   =plot()
   =w()
   * 2.5D view of bar chart
   =FONT_SAY(Mtext,5,160,"* 2.5D bar graphs")
   =view_clear(M_view,atx(40,2),0,mBaseh,mBasev)
   =set_3d(rotation,0)
   =plot()
   =w()
   * 2.5D view of bar chart side by side bars
   =FONT_SAY(Mtext,5,185,"* 2.5D side by side bars bar graphs")
   =view_clear(M_view,atx(40,2),0,mBaseh,mBasev)
   =set_3d(rotation,0,.F.,1)
   =plot()
   =w()
   =view_clear(M_view,atx(40,2),0,mBaseh,mBasev)
   * stacked bar
   =FONT_SAY(Mtext,5,210,"* stacked bar graphs")
   =set_column(1,0,4)
   =set_column(2,0,4)
   =set_column(3,0,4)
   =set_column(4,0,4)
   =set_column(5,0,5)
   =plot()
   =w()
   =view_clear(M_view,atx(40,2),0,mBaseh,mBasev)
   * line
   =set_3d(rotation,elevation,.F.,0)
   =FONT_SAY(Mtext,5,235,"* line graphs")
   =set_column(1,0,1)
   =set_column(2,0,1)
   =set_column(3,0,1)
   =set_column(4,0,1)
   =plot()
   =w()
   =view_clear(M_view,atx(40,2),0,mBaseh,mBasev)

   * multi
   =FONT_SAY(Mtext,5,260,"* and multiple type graphs.")
   =set_column(1,0,2)
   =set_column(2,0,3)
   =set_column(3,0,1)
   =set_column(4,0,5)
   =plot()
   =w()

   * allow user to rotate, elevate
*   =FONT_SAY(Mtext,5,285,"The graph can be rotated and")
*   =FONT_SAY(Mtext,5,205,"elevated.  Now you try it!")
*   =w()

   =view_show(M_view,1)
   M_view = VIEW_OPEN(0,0,mbaseh/2-10,mbasev-10,-1,-1,-1,"Flipper for FoxPro Demo")
   M_ok=VIEW_SHOW(M_view,3)
   M_ok=VIEW_SHOW(M_view,4)
   M_view=VIEW_SET(M_view)

   =SET_GRAPH(0,"Rotation:"+STR(rotation,3,0)+" Elevation:"+STR(elevation,3,0))
   =set_graph(4,0,0,100,100)
   =plot()
   =wc()

   rotation=10
   elevation=20
   =SET_GRAPH(0,"Rotation:"+STR(rotation,3,0)+" Elevation:"+STR(elevation,3,0))
   =set_3d(rotation,elevation)
   =plot()
   =wc()

   rotation=120
   elevation=30
   =SET_GRAPH(0,"Rotation:"+STR(rotation,3,0)+" Elevation:"+STR(elevation,3,0))
   =set_3d(rotation,elevation)
   =plot()
   =wc()

   * true 3-d
   =VIEW_SHOW(M_view,1)
   M_view = VIEW_OPEN(0,0,100,100,-1,-1,-1,"Flipper for FoxPro Demo")
   M_ok=VIEW_SHOW(M_view,3)
   M_ok=VIEW_SHOW(M_view,4)
   M_view=VIEW_SET(M_view)
   =VIEW_SIZE(M_view,0,0,mBaseh,mBasev)
   =c()
   =FONT_SAY(Mtext,5,50,"Flipper for FoxPro uses true")
   =FONT_SAY(Mtext,5,75,"3-D graphing, so that you can")
   =FONT_SAY(Mtext,5,100,"change the perspective of your")
   =FONT_SAY(Mtext,5,125,"graphs.")
   =FONT_SAY(Mtext,5,160,"Sure, May looks like a good")
   =FONT_SAY(Mtext,5,185,"month for sales now...")
   =graphData(3)
   =set_graph(4,45,0,100,100)
   =plot()
   =wc()
   =FONT_SAY(Mtext,5,50,"But change the perspective a")
   =FONT_SAY(Mtext,5,75,"little, and sales for May look")
   =FONT_SAY(Mtext,5,100,"great!")
   =set_3d(45,elevation,1600)
   =plot()
   =wc()
RETURN

PROCEDURE drawTour
   =VIEW_SHOW(M_view,3)
   M_ok=VIEW_SHOW(M_view,4)
   M_view=VIEW_SET(M_view)
   =FONT_SAY(Mtext,5,50,"All of the drawing")
   =FONT_SAY(Mtext,5,75,"tools used to make")
   =FONT_SAY(Mtext,5,100,"these graphs are in")
   =FONT_SAY(Mtext,5,125,"your hands as well.")
   =FONT_SAY(Mtext,5,150,"There are functions")
   =FONT_SAY(Mtext,5,175,"for drawing lines,")
   =FONT_SAY(Mtext,5,200,"boxes, arcs, circles,")
   =FONT_SAY(Mtext,5,225,"and polygons. Apply")
   =FONT_SAY(Mtext,5,250,"these directly to")
   =FONT_SAY(Mtext,5,275,"your graphs for better")
   =FONT_SAY(Mtext,5,300,"appearance!")

   =graphData(11)
   =plot()

   row=1
   col=1
   totcols=2

   for row=1 to 5
		for col=1 to totcols
			DO barMiddle with row,col,totcols,middle,top
				if col=1
					=moon(middle,top)
				else
					=sun(middle,top)
				endif
		next col
   next row

   =wc()
RETURN

PROCEDURE closing
   M_ok=VIEW_SHOW(M_view,4)
   M_view=VIEW_SET(M_view)
   =FONT_SAY(Mtext,5,50,"All graphs can be copied to the clipboard as a bitmap or metafiles")
   =FONT_SAY(Mtext,5,75,"for use in other applications such as word processors. Also, graphs")
   =FONT_SAY(Mtext,5,100,"can be saved to disk as a bitmap. A bitmaps can be displayed from disk.")
    =w()
   =FONT_SAY(Mtext,5,150,"The source code for this demo is in the directory where it was installed.")
   =FONT_SAY(Mtext,5,175,"The Flipgraf.fll is a demo version of the library that is fully functional")
   =FONT_SAY(Mtext,5,200,"except for an information box that can be moved out of the way.")
   =FONT_SAY(Mtext,5,250,"The Flipgraf.hlp is also included so you can see the documentation.")
   =wc()
   =FONT_SAY(Mtext,5,50,"ProWorks thanks you for your time and attention. If you would like")
   =FONT_SAY(Mtext,5,75,"further information about this graphics library, contact ProWorks at")
   =FONT_SET(Mtext,1,1)
   =FONT_SAY(Mtext,ATX(40,2),220,"ProWorks")
   =FONT_SAY(Mtext,ATX(40,2),245,"503-567-1459")
   =FONT_SAY(Mtext,ATX(40,2),270,"P.O. Box 1635")
   =FONT_SAY(Mtext,ATX(40,2),295,"Hermiston, OR, USA 97838")
   =FONT_SAY(Mtext,ATX(40,2),340,"That's the end!")

   =inkey(0,"m")
RETURN

PROCEDURE graphData
PARAMETERS x
   DO CASE
	 CASE x=1
	    =FLIP_RESET()
	    =INITDATA(5)
	    =SET_GRAPH(0,"Precipitation of Pacific NorthWest Cities")
	    *		  Description	 Value  Explosion  Color Column Style
	    =STORE_DATA("Hermiston",   22.335,  100,     14,      1)
	    =STORE_DATA("Lynwood",     15.234,  0,       16,      1)
	    =STORE_DATA("Ontario",     25.2, 0,       17,      1)
	    =STORE_DATA("Pleasant Hill",27,     0,       18,      1)
	    =STORE_DATA("Grants Pass", 8.231,   0,       21,      1)
	 CASE x=2
	    =FLIP_RESET()
	    =INITDATA(5)
	    =SET_GRAPH(0,"Weekly Results")
	    =SET_AXIS(0,0,"Days")
	    =SET_AXIS(1,0,"Quantity")
	    =STORE_DATA("Mon",32,26,57,46)
	    =STORE_DATA("Tue",43,36,27,32)
	    =STORE_DATA("Wed",38,21,6,2)
	    =STORE_DATA("Thur",35,20,18,25)
	    =STORE_DATA("Fri",40,13,24,33)
	    =STORE_DATA("Sat",63,45,25,22)
	    =STORE_DATA("Sun",46,37,36,27)
	    =SET_PEN(0)
	    =SET_GRAPH(10,8)
	 CASE x=3
	    =FLIP_RESET()
	    =INITDATA(3)
	    MaxisFont=FONT_OPEN("Times New Roman,12,I")
	    =SET_GRAPH(0,"ProWorks and Pizza Inc.|Would you like breadsticks with your Flipper?")
	    =SET_GRAPH(1,Mtext)
	    =SET_GRAPH(2,MaxisFont)
	    =STORE_DATA("Jan",10,6)
	    =STORE_DATA("Feb",9,8)
	    =STORE_DATA("March",9,7)
	    =STORE_DATA("April",7,7)
	    =STORE_DATA("May",10,11)
	    =set_column(1,0,2)
	    =set_column(2,0,3)
	    =set_column(1,7,"Net Worth")
	    =set_column(2,7,"Sales")
	    =set_3d(15,20)
	    =set_axis(1,4,1)
	    =set_axis(1,5,0)
	    =set_axis(1,6,10)
	    =set_axis(1,7,1)
	    =legend_set(65,15,1,0,0,2,2,22)
	    =set_graph(15,.45)
	    =set_column(2,3,1)
	    =SET_GRAPH(10,8)
	 CASE x=4
	    =FLIP_RESET()
	    =INITDATA(4)
	    =store_data("Dairy",23,15,36)
	    =store_data("Fruit",11,34,26)
	    =store_data("Veggies",51,8,1)
	    =store_data("White Meat",12,22,7)
	    =store_data("Red Meat",5,15,32)
	    =store_data("Tofu",10,12,4)
	    =set_column(1,0,2)
	    =set_column(2,0,2)
	    =set_column(3,0,2)
	 CASE x=5
	    =set_graph(4,40,0,100,50)
	    =store_data("Grains",17,29,35)
	    =store_data("Fluids",8,39,4)
	    =store_data("Sweets",25,37,39)
	    =set_column(1,0,1)
	    =set_column(2,0,1)
	    =set_column(3,0,1)
	    =set_column(1,6,6)
	    =set_column(2,6,6)
	    =set_column(3,6,6)
	    =set_graph(5,0)
	    =set_axis(1,11,2)
	    =set_graph(6,14)
	    =set_graph(10,0)
	 CASE x=6
	    =set_graph(4,40,50,100,100)
	    =set_column(1,0,2)
	    =set_column(2,0,2)
	    =set_column(3,0,2)
	    =set_column(1,5,11)
	    =set_column(2,5,14)
	    =set_column(3,5,21)
	    =set_column(1,3,1)
	    =set_column(2,3,1)
	    =set_column(3,3,1)
	    =set_graph(10,10)
	 CASE x=7
	    i=0
	    for i=1 to 9
		  =store_val(i,2,-store_val(i,2))
	    next i
	    =set_column(3,0,0)

	    =set_graph(4,40,0,100,100)
	    =set_column(1,0,3)
	    =set_column(2,0,3)
	    =set_column(1,5,17)
	    =set_column(2,5,10)
	    =set_graph(10,8)
	    =set_graph(13,1)
	    =set_axis(1,5,-30)
	    =set_axis(1,6,30)
	    =set_axis(1,7,5)
	    =set_axis(1,11,0)
	    =set_axis(1,4,1)
	    =set_axis(0,0,"Goods")
	    =set_axis(1,0,"Quantity")
	    =set_graph(0,"Consumption of Goods")

	 CASE x=8
	    for i=1 to 9
		  =store_val(i,2,-store_val(i,2))
	    next i
	    =set_axis(1,4,0)
	    =set_column(1,0,2)
	    =set_column(2,0,2)
	    =set_column(3,0,2)
	    =set_column(1,5,6)
	    =set_column(2,5,13)
	    =set_column(3,5,20)
	    =set_column(1,3,1)
	    =set_column(2,3,1)
	    =set_column(3,3,1)
	    =set_column(1,7,"Mom")
	    =set_column(2,7,"Dad")
	    =set_column(3,7,"Little Jimmy")
	    =legend_set(2,2,1,0,0,2,2,19,2)
	    =set_graph(10,5)
	    graphTitleFont=FONT_OPEN("Arial,20,BN")
	    =set_graph(1,graphTitleFont)
	    axisFont=FONT_OPEN("Times New Roman,16,I")
	    =set_graph(2,axisFont)
	    scaleFont=FONT_OPEN("Courier New,10,N")
	    =set_graph(3,scaleFont)
	    =set_graph(13,0)
	 CASE x=9
	    =FLIP_RESET()
	    =INITDATA(3)
	    =SET_GRAPH(4,40,0,100,100)
	    =STORE_DATA("1988",58,49)
	    =STORE_DATA("1989",26,56)
	    =STORE_DATA("1990",18,52)
	    =STORE_DATA("1991",25,73)
	    =STORE_DATA("1992",12,36)
	    =STORE_DATA("1993",9,38)
	    =STORE_DATA("1994",42,35)
	    =SET_AXIS(0,0,'Years')         && Set the X axis label
	    =SET_AXIS(1,0,'Total')        && Set the left Y axis label
	    =SET_AXIS(1,11,1)
	    =SET_GRAPH(0,"Net Worth")
	    =SET_COLUMN(1,0,3)
	    =SET_COLUMN(2,0,2)
	    =SET_COLUMN(2,3,1)
	    =SET_COLUMN(1,7,"Projected")
	    =SET_COLUMN(2,7,"Actual")
	    =LEGEND_SET(50,10,1,0,0,2,2,22)
	    =SET_AXIS(0,11,1)
	    =SET_AXIS(1,11,1)
	    =SET_GRAPH(6,15)
	 CASE x=10
	    =FLIP_RESET()
	    =INITDATA(6)
	    =STORE_DATA("Oregon",10,34,20,0,10)
	    =STORE_DATA("Montana",25,12,23,10,21)
	    =STORE_DATA("Texas",30,32,12,7,6)
	    =STORE_DATA("Iowa",14,42,30,20,35)
	    =STORE_DATA("Georgia",40,23,37,9,8)
	    =SET_COLUMN(1,0,1)
	    =SET_COLUMN(2,0,1)
	    =SET_COLUMN(3,0,1)
	    =SET_COLUMN(4,0,0)
	    =SET_COLUMN(5,0,0)
	 CASE x=11
	    =FLIP_RESET()
	    =initdata(3)
	    =store_data("Monday",44,78)
	    =store_data("Tuesday",37,85)
	    =store_data("Wednesday",46,92)
	    =store_data("Thursday",45,90)
	    =store_data("Friday",35,87)

	    =set_graph(4,30,0,100,100)
	    =set_column(1,0,3)
	    =set_column(2,0,3)
	    =set_column(2,5,16)
	    =set_graph(0,"Weekday Temperatures")
	    titleFont=FONT_OPEN("Times New Roman,16,B")
	    =set_graph(1,titleFont)
	    =set_axis(1,0,"Temperature in Farenheit")
	    =set_column(1,7,"Nightly lows")
	    =set_column(2,7,"Daily highs")
	    =set_column(2,3,1)
	    =set_graph(10,0)

	    =legend_set(2,2,1,0,0,2,2,22,2)
	 ENDCASE
RETURN

PROCEDURE wc
* wait and clear
   =w()
   =c()
RETURN

PROCEDURE pc
* wait and clear the pie region
   =w()
   =view_clear(M_view,ATX(40,2),mBaseh,mBasev)
RETURN

PROCEDURE w
* wait
   =inkey(M_sec,"m")
RETURN

PROCEDURE c
* clear
   =view_clear(M_view)
RETURN

PROCEDURE HOT_BACK
x=0
y=0

=MSPOSITION(M_view,@x,@y)

if temp_view = 0
   temp_view=VIEW_OPEN(x,y,x+85,y+75,512,2,1)
endif

DIMENSION marray(9),marray1(3)
=HOT_GET(1,@marray,@marray1)

mStr=""
DO CASE
   CASE marray[1] = BIT(0)
	 mStr="Direct"
   CASE marray[1] = BIT(1)
	 mStr="Mark"
   CASE marray[1] = BIT(2)
	 mStr="Bar"
   CASE marray[1] = BIT(3)
	 mStr="Line"
   CASE marray[1] = BIT(4)
	 mStr="Area"
   CASE marray[1] = BIT(5)
	 mStr="Hi-Lo"
   CASE marray[1] = BIT(6)
	 mStr="Frame"
   CASE marray[1] = BIT(7)
	 mStr="Legend"
   CASE marray[1] = BIT(8)
	 mStr="Scale label"
   CASE marray[1] = BIT(9)
	 mStr="Grid line"
   CASE marray[1] = BIT(10)
	 mStr="Zero line"
   CASE marray[1] = BIT(11)
	 mStr="Graph title"
   CASE marray[1] = BIT(12)
	 mStr="Scale title"
   CASE marray[1] = BIT(13)
	 mStr="Pie slice"
ENDCASE

nWidth=0
nHeight=0
nFontHeight=0
=GET_EXTENT( boxFont, mStr, @nWidth, @nFontHeight )
nWidth1=0

IF marray[2] = 20
   =GET_EXTENT( boxFont, chr(34)+marray1[1]+chr(34), @nWidth1, @nHeight )
   nHeight = nFontHeight*2
ELSE
   IF marray1[1] != -1
	 =GET_EXTENT( boxFont, 'Value: '+ALLTRIM(STR(STORE_VAL(marray1[1],marray1[2]))), @nWidth1, @nHeight )
	 nHeight = nFontHeight*4
   ELSE
	 nHeight = nFontHeight*2
   ENDIF
ENDIF
IF nWidth < nWidth1
   nWidth = nWidth1
ENDIF

=VIEW_SIZE(temp_view,x,y,x+nWidth+4,y+nHeight+4)
=VIEW_CLEAR(temp_view)
=VIEW_SHOW(temp_view,3)
=VIEW_SHOW(temp_view,4)
=VIEW_SET(temp_view)

y=2
=FONT_SET(boxFont,0,0)
=FONT_SAY(boxFont,0,y,mStr)
IF marray[2] = 20
   y=y+nFontHeight
   =FONT_SAY(boxFont,0,y,chr(34)+marray1[1]+chr(34))
ELSE
   row=marray1[1]
   col=marray1[2]
   IF row !=-1
	 y=y+nFontHeight
	 =FONT_SAY(boxFont,0,y,'Row:'+STR(row,3,0))
	 y=y+nFontHeight
	 =FONT_SAY(boxFont,0,y,'Col: '+STR(marray1[2],3,0))
	 y=y+nFontHeight
	 =FONT_SAY(boxFont,0,y,'Value: '+ALLTRIM(STR(STORE_VAL(row,col))))
   ENDIF
ENDIF

*=inkey(2)
*=VIEW_CLEAR(temp_view)
*=VIEW_SHOW(temp_view,2)
=VIEW_SET(M_view)
RELEASE marray,marray1

RETURN

PROCEDURE sun
PARAMETERS x,y
   =set_pen(19)
   =set_brush(1,19,2,19)
   =drawcurve(0,x,y,10,10)
   =drawline(x,y-12,x,y-15)
   =drawline(x+12,y,x+15,y)
   =drawline(x-12,y,x-15,y)
   =drawline(x,y+12,x,y+15)
   =drawline(x+9,y-7,x+12,y-10)
   =drawline(x+9,y+7,x+12,y+10)
   =drawline(x-9,y+7,x-12,y+10)
   =drawline(x-9,y-7,x-12,y-10)
   =set_pen(0)
   =drawcurve(1,x,y+2,5,3,1800,3700)
RETURN

PROCEDURE moon
PARAMETERS x,y
   =set_pen(22)
   =set_brush(1,22,2,22)
   =drawcurve(1,x,y,10,10,2600,1100)
   =drawcurve(1,x,y,3,10,2600,3500)
   =drawcurve(1,x,y,3,10,100,1100)
   =drawcurve(1,x+2,y+1,3,2,450,3150)
   =fillarea(x+2,y,22,1)
   =set_pen(0)
   =drawcurve(1,x+2,y+5,3,2,2250,0)
RETURN

PROCEDURE barMiddle
PARAMETERS row, col, totcols, middle, top
	tickWidth=0
	barWidth=0
	startOfBars=0

	tickWidth=ATX(2,1)-ATX(1,1)
	barWidth=(tickWidth*.75)/totcols
	startOfBars=ATX(row-1,1)-(.375*tickWidth)
	middle=startOfBars+barWidth*col - barWidth/2
	top = ATY( STORE_VAL(row,col) ,1 ,1 ) - 15
RETURN
*************** E O F ***********************************
